AddRecordAssistant = Class.create({
	initialize: function(uids) {
		this.categoryuid = uids.categoryuid;
		this.typeuid = uids.typeuid;
		this.chosenCategory = uids.categoryuid;
		this.chosenType = uids.typeuid;
		this.password = SplashIDWorld.password;
		Mojo.Log.info('password: ', this.password);
		this.labelsFields = ['', '', '', '', '', '', '', ''];
		this.valuesFields = ['', '', '', '', '', '', '', ''];
		
		this.dateModified = 0;
		this.description = '';
		this.notes = '';
		this.selection = null;
		this.type = undefined;
		this.customType = undefined;
		this.categoryuid = this.categoryuid.replace(/'/g, "");
		this.typeuid = this.typeuid.replace(/'/g, "");
		Mojo.Log.info("category UId: ", this.chosenCategory, ", typeuid: ", this.chosenType, "   --done");
	},
	
    setup: function() {
		this.setupTextWidget('description', '', this.descriptionChanged.bind(this), undefined);
		var labelsFields = ['field1', 'field2', 'field3', 'field4', 'field5', 
		                     'field6', 'field7', 'field8'];
		for (var i = 0; i < labelsFields.length; ++i) {
			this.setupTextWidget(labelsFields[i], '', this.fieldChanged.bind(this), i);
		}
		this.setupTextWidget('datemod', '', undefined, undefined);
		this.setupTextWidget('notes', 'Your notes here...', this.notesChanged.bind(this), undefined);
		
		/* setup the save, clear, customize fields, and return (command) menu items */
		this.setupCommandMenu();
		this.setupTypesAndCategoriesSelectionMenu();
		this.selection = new TypesAndCategoriesSelection(this,  
														 false, 
														 this.chosenType,
														 this.chosenCategory);
		this.controller.listen('icon', Mojo.Event.tap, this.showIconPicker.bindAsEventListener(this));
	},
	
	activate: function(event) {
		if (SplashIDWorld.timer) {
			SplashIDWorld.timer.reset();
		}
		Mojo.Log.info("activate add records");
		if (event && event instanceof SplashIDEvent) {
			if (event.src == SplashIDWorld.Activities.CustomizeFieldsActivity) {
				Mojo.Log.info("activate: custom type ");
				this.customType = event.customType;
				for (field in this.customType) {
					Mojo.Log.info(field, ": ", this.customType[field]);
					this.setTypeLabels(this.customType);
				}
			}
		} 
		else {
			new SplashIDTypesRepo().getTypeData(this.chosenType, false, this.setTypeInfoOnRecord.bind(this));
			new SplashIDCategoriesRepo().getCategoryData(this.chosenCategory, this.setCategoryInfo.bind(this));
		}
	},
	
	setTypeInfoOnRecord: function(typedata) {
		if (SplashIDWorld.timer) {
			SplashIDWorld.timer.reset();
		}
		var typeFields = [typedata.field1, typedata.field2, typedata.field3, typedata.field4,typedata.field5,
						  typedata.field6, typedata.field7, typedata.field8, typedata.field9];
		var typeValues = [];
		var typename = typedata.name;
		if (SplashIDWorld.password && !SplashIDWorld.password.blank()) {
			typename = Mojo.Model.decrypt(SplashIDWorld.password, typedata.name);
		}
		for (var i = 0; i < typeFields.length; i++) {
			if (SplashIDWorld.password && !SplashIDWorld.password.blank()) {
				typeValues[i] = Mojo.Model.decrypt(SplashIDWorld.password, typeFields[i])
			} else {
				typeValues[i] = typeFields[i];
			}
		}
		$('desc-label').innerText = typeValues[0];
		$('field1-label').innerText = typeValues[1];
		$('field2-label').innerText = typeValues[2];
		$('field3-label').innerText = typeValues[3];
		$('field4-label').innerText = typeValues[4];
		$('field5-label').innerText = typeValues[5];
		$('field6-label').innerText = typeValues[6];
		$('field7-label').innerText = typeValues[7];
		$('field8-label').innerText = typeValues[8];
		$('icon').src ="url(images/drawable/high" + typedata.iconid + ".png)";
		this.type = {
					 'iconid': typedata.iconid,
					 'uid': typedata.uid,
					 'name': typename, 
					 'mask': typedata.mask,
					 'field1': typeValues[0],  
					 'field2': typeValues[1], 
					 'field3': typeValues[2],
					 'field4': typeValues[3],
					 'field5': typeValues[4],
					 'field6': typeValues[5],
					 'field7': typeValues[6], 
					 'field8': typeValues[7], 
					 'field9': typeValues[8]
					};
		for ( f in this.type) {
			Mojo.Log.info ("type field: ", f, ", value: ", this.type[f] );
//			Mojo.Log.info("******* selected name is: ", this.type.name, " lable is: ", Mojo.Menu.viewMenu.items(0).label, " *******");

		}
		
		this.viewMenuModel.items[0].label = this.type.name;
		this.controller.modelChanged(this.viewMenuModel);  

	},
	
	
	
	setupTextWidget: function(name, hintText, handlerContentChange, index) {
		var attrWidget = {
			hintText: hintText,
			multiline: true,
			enterSubmits: false,
			focusMode: Mojo.Widget.focusInsertMode,
			changeOnKeyPress: true,
		};
		var modelWidget = {
			'index': index,
			'value': '',
			disabled: (handlerContentChange == undefined),
		};

		this.controller.setupWidget(name, attrWidget, modelWidget);
		if (handlerContentChange) {
			this.controller.listen(name, Mojo.Event.propertyChange, handlerContentChange);
		}
	},
	
	notesChanged: function(event) {
		this.notes = event.value || "";
		if (SplashIDWorld.timer) {
			SplashIDWorld.timer.reset();
		}
	},
	
	fieldChanged: function(event) {
		this.valuesFields[event.model.index] = event.value || "";
		if (SplashIDWorld.timer) {
			SplashIDWorld.timer.reset();
		}
	},
	
	descriptionChanged: function(event) {
		this.description = event.value || "";
		if (SplashIDWorld.timer) {
			SplashIDWorld.timer.reset();
		}
	},
	
	setupTypesAndCategoriesSelectionMenu: function() {
		
		this.viewMenuModel = {items: [{label:'', command:'type', width:155},
                               		  {label:'', command:'category', width:155}]
	                           		};

		this.controller.setupWidget(Mojo.Menu.viewMenu, 
				                    undefined, 
				                    this.viewMenuModel);
	},
	
	setupCommandMenu: function() {
		this.controller.setupWidget(Mojo.Menu.commandMenu, 
                undefined, 
		        {items: [{items: [
		                          { icon: "back", command: "goBack"},
		                          {label:'Save',     command:'save'}]},
						 {items: [{label:'Customize', command:'cust'}]}
           				]
           		});
				
		this.controller.setupWidget();
	},
	
	handleCommand: function(event) {
		
		if (event.type == Mojo.Event.commandEnable && (event.command == Mojo.Menu.helpCmd)) {
         	event.stopPropagation(); // enable help. now we have to handle it
    	}
		
		if(event.type == Mojo.Event.command) {
			if (SplashIDWorld.timer) {
				SplashIDWorld.timer.reset();
			}
			if (event.command == 'type') {
				this.selection.popupTypes(event);
			} else if (event.command == 'category') {
				this.selection.popupCategories(event);
			} else if (event.command == 'goBack') {
				this.controller.stageController.popScene();	
			} else if (event.command == 'save') {
				if (this.description.blank()) {
					this.showEmptyDescriptionAlert();
				}
				else {
					var customTypeuid;
					if (this.customType) {
						customTypeuid = this.insertTypeToCustomTypes(this.customType);
						Mojo.Log.info('custom typeuid: ', customTypeuid);
					}
					else {
						this.saveRecord()
					};
				}
			} else if (event.command == 'clr ') {
			} else if (event.command == 'cust') {
				Mojo.Log.info("customize fields");
				this.controller.stageController.pushScene('customFields', this.type);
			} else if (event.command == 'done') {
				this.controller.stageController.popScene();
			} else if (event.command == Mojo.Menu.helpCmd) {
				Mojo.Controller.stageController.pushScene('support');
			}
		}
	},

	OnTypeSelected: function(uidType) {
		Mojo.Log.info("******** type selected is: ", uidType,  "  ************");
		
		this.customType = null;
		
		if (SplashIDWorld.timer) {
			SplashIDWorld.timer.reset();
		}
		this.typeuid = uidType;

		if (uidType == 'FFFFFFFFFFFFFFFF') {
			this.chosenType = 'typestable.uid';
		} else {
			this.chosenType = "'" + uidType + "'";
			Mojo.Log.info('**********************Chosen Type: ', this.chosenType);
		}
		
		if (SplashIDWorld.timer) {
			SplashIDWorld.timer.reset();
		}
		this.typeuid = uidType;
		new SplashIDTypesRepo().getTypeData(this.chosenType, false, this.setTypeInfoOnRecord.bind(this));
	},
	
	OnCategorySelected: function(uidCategory) {
		Mojo.Log.info("****** OnCategorySelected ***********");
		if (SplashIDWorld.timer) {
			SplashIDWorld.timer.reset();
		}
		
		if (uidCategory == 'FFFFFFFFFFFFFFFF') {
			this.chosenCategory = 'catagoriestable.uid';
		} else {
			this.chosenCategory = "'" + uidCategory + "'";
		}
		
		this.categoryuid = uidCategory;		
		Mojo.Log.info("**** category is: ", uidCategory);
		
		// to get the category name //
		new SplashIDCategoriesRepo().getCategoryData(this.chosenCategory, this.setCategoryInfo.bind(this));
		
		
	},
	
	saveRecord: function() {
		if (SplashIDWorld.timer) {
			SplashIDWorld.timer.reset();
		}
		Mojo.Log.info("add new record");
		
		var recordValues = new ContentValues();
		var newRecord = new ContentValues();
		newRecord = this.fillRecordDetails();
		newRecord.put('flags', 0);
		newRecord.put('hascustomfield', 0);

		if (SplashIDWorld.database == undefined) {
			SplashIDWorld.database = new SQLOperations('splashid');
		}

		var resultHandler = new Array();	
		resultHandler.push(this.onSaveSuccess.bind(this));
		resultHandler.push(this.onFailure.bind(this));
		
		Mojo.Log.info(" before retrieve record");		
		SplashIDWorld.database.insertRecord("recordstable", newRecord, resultHandler);	
		
	},
	
	showEmptyDescriptionAlert: function() {
		if (SplashIDWorld.timer) {
			SplashIDWorld.timer.reset();
		}
		this.controller.showAlertDialog({
			title: 'Alert - Invalid Field Value',
			message: "Please make sure the 'Description' field is not empty",
			preventCancel: true,
			choices: [{label:'ok', value:10}]
		});
	},
	
	fillRecordDetails: function() {
		var uid = new UUID().toString();
		uid = uid.split('-').join('');
		uid = uid.substring(uid.length-16, uid.length);
		var duid = parseInt(uid.substring(2, 14), 16);
		Mojo.Log.info("uid of new record: ", uid, ", duid: ", duid);

		var categoryuid = this.categoryuid;
		if (this.categoryuid == 'FFFFFFFFFFFFFFFF') {
			categoryuid = '0000000000000000';
		}
		
		var typeuid = this.typeuid;
		if (this.typeuid == 'FFFFFFFFFFFFFFFF') {
			typeuid = '0000000000000000';
		}
		var newRecord = new ContentValues();
		var recordValues = new ContentValues();
		var labelsFields = ['value1', 'value2', 'value3', 'value4', 'value5', 
		                    'value6', 'value7', 'value8', 'value9'];
		var values = [this.description, this.valuesFields[0], this.valuesFields[1], this.valuesFields[2], 
						  this.valuesFields[3], this.valuesFields[4], this.valuesFields[5],
						  this.valuesFields[6], this.valuesFields[7]];
		//recordValues.put('notes', this.notes);	
		//console.log("notes: " + this.notes);
		for ( var i = 0; i < values.length; i++) {
			if (values[i]) {
				var j= i + 1;
				Mojo.Log.info ('value', j, " : ", values[i]);
				recordValues.put (labelsFields[i], values[i]);
			}
		}				
		
		if (this.notes != undefined && !this.notes.blank()) {
			recordValues.put('notes', this.notes);
		}

		var currDate = getFormattedDate();
		Mojo.Log.info("current formatted date: ", currDate);
		Mojo.Log.info('before encryption:');
		newRecord = encryptRecord(SplashIDWorld.password, recordValues);
		newRecord.put('uid', uid);
		newRecord.put('duid', duid);
		newRecord.put('typeuid', typeuid);
		newRecord.put('categoryuid', categoryuid);
		newRecord.put('value10', currDate);
		//Mojo.Log.info('*****types uid: ', typeuid);
		return newRecord;	
	},
	
	insertTypeToCustomTypes: function(customType) {
		if (SplashIDWorld.timer) {
			SplashIDWorld.timer.reset();
		}
		Mojo.Log.info("insert to custom types");
		var customTypeValues = new ContentValues();
		var recordValues = new ContentValues();
		var fields = ['name', 'field1', 'field2', 'field3', 'field4',
		              'field5', 'field6', 'field7', 'field8', 'field9'];
		var labelsFields = ['value1','value2', 'value3', 'value4', 'value5', 'value6', 
                            'value7', 'value8', 'value9', 'value10'];	
		var uid = new UUID().toString();
		uid = uid.split('-').join('');
		uid = uid.substring(uid.length-16, uid.length);
		
						  
		for (i = 0; i < fields.length; i++) {
			if (customType[fields[i]] != undefined && !customType[fields[i]].blank() ) {
				customTypeValues.put(fields[i], customType[fields[i]]);
			}
		}
		
		var newRecord = new ContentValues();
		newRecord = this.fillRecordDetails();
		newRecord.put('hascustomfield', 1);
		newRecord.put('customtypeuid', uid);
		
		Mojo.Log.info('*****custom type uid uid: ', uid);

		if (SplashIDWorld.database == undefined) {
			SplashIDWorld.database = new SQLOperations('splashid');
		}

		var resultHandler = new Array();	
		resultHandler.push(this.onCustomSuccess.bind(this));
		resultHandler.push(this.onFailure.bind(this));

		SplashIDWorld.count = 0;
				
		var encCustomType = new ContentValues();		
		encCustomType = encryptRecord(SplashIDWorld.password, customTypeValues);
		encCustomType.put('uid', uid);
		encCustomType.put('iconid', customType.iconid);
		encCustomType.put('mask', customType.mask);
		SplashIDWorld.database.insertRecord("customtypestable", encCustomType, resultHandler);
		SplashIDWorld.database.insertRecord("recordstable", newRecord, resultHandler);					

	},
	
	setTypeLabels: function(typedata) {
		$('desc-label').innerText = typedata.field1;
		$('field1-label').innerText = typedata.field2;
		$('field2-label').innerText = typedata.field3;
		$('field3-label').innerText = typedata.field4;
		$('field4-label').innerText = typedata.field5;
		$('field5-label').innerText = typedata.field6;
		$('field6-label').innerText = typedata.field7;
		$('field7-label').innerText = typedata.field8;
		$('field8-label').innerText = typedata.field9;
		
		$('icon').src ="url(images/drawable/high" + typedata.iconid + ".png)";
	},
	
	showIconPicker: function(event) {
		if (SplashIDWorld.timer) {
			SplashIDWorld.timer.reset();
		}
		Mojo.Log.info("Show Icon picker");
		this.iconPickerDlg = this.controller.showDialog({
						template: 'iconPicker/iconPicker-scene',
						assistant: new IconPickerAssistant(this),
						});
	},
	
	onIconSelected: function(iconid) {
		if (SplashIDWorld.timer) {
			SplashIDWorld.timer.reset();
		}
		if (!this.customType) {
			this.customType = this.type;
		}
		this.customType.iconid = iconid;
		$('icon').src ="url(images/drawable/high" + iconid + ".png)";
	},
	
	closeIconPicker: function() {
		if (SplashIDWorld.timer) {
			SplashIDWorld.timer.reset();
		}
		this.iconPickerDlg.mojo.close();
	},
	
	
	// set the selected category as the view menu name
	setCategoryInfo: function(typedata) {

		Mojo.Log.info("setCategoryInfo");
		if (SplashIDWorld.timer) {
			SplashIDWorld.timer.reset();
		}

		var typename = typedata.name;

		if (SplashIDWorld.password && !SplashIDWorld.password.blank()) {
			typename = Mojo.Model.decrypt(SplashIDWorld.password, typedata.name);
		}
		
		Mojo.Log.info("typename is: ", typename);
		this.viewMenuModel.items[1].label = typename;
		this.controller.modelChanged(this.viewMenuModel);  

	},
	
	onSaveSuccess: function(transaction, sqlResultSet) {
		Mojo.Log.info(" AddRecordAssistant - onSaveSuccess");
		var event = new SplashIDEvent().setParams(SplashIDWorld.Activities.AddRecordActivity,
											  'shouldRefresh');
		Mojo.Log.info("Record Added");
		this.controller.stageController.popScene(event);
	},
	

	onFailure: function(transaction, error) {
		Mojo.Log.info(" AddRecordAssistant - onFailure");			
		Mojo.Log.info(' Error is ', error.message,  ' Code is ', error.code);
	},
	
	onCustomSuccess: function(transaction, sqlResultSet) {
		Mojo.Log.info(" AddRecordAssistant - onCustomSuccess");
		SplashIDWorld.count++;

		if (SplashIDWorld.count == 2) {
			var event = new SplashIDEvent().setParams(SplashIDWorld.Activities.AddRecordActivity, 'shouldRefresh');
			this.controller.stageController.popScene(event);
		}
	},
})
