DetailedViewAssistant = Class.create({
	
	initialize: function(record,type) {
		this.record = record;
		this.mask = true;
		this.type = type;
		this.password = SplashIDWorld.password;
		for (field in this.type) {
			Mojo.Log.info(field, ": ", this.type[field]);	
			
		}
		Mojo.Log.info('record details');	
		for (rf in this.record) {
			Mojo.Log.info(rf, ': ', this.record[rf]);
			
		}
	},
	
	setup: function() {
		Mojo.Log.info('setup:DetailedView of a record');
		
		this.setupCommandMenu();
		
		$('icon').src ="url(images/drawable/high" + this.record.iconid + ".png)";
		
		/*
		 * To Remove the unneccessry display of blank items in info
		 */
		$('description').innerText = this.record.value1;
		this.displayDateTypeAndCategory();
		this.unmaskRecord();
		this.maskRecord();
	},
	
	activate: function(event) {
		
		if (SplashIDWorld.timer) {
			SplashIDWorld.timer.reset();
		}
		
		if (event && event instanceof SplashIDEvent) {
			if (event.src == SplashIDWorld.Activities.EditRecordActivity) {
				if (event.editedRecord) {
					this.record = event.editedRecord;
				}
				if (event.customType) {
					this.type = event.customType;
					$('type').innerText = this.type.name;
				}
				if (event.type) {
					Mojo.Log.info("type from edit record");
					
					this.type = event.type;
					if (event.type.typedata) {
						this.type.name = event.type.typedata.name;
					}
					for (f in event.type) {
						Mojo.Log.info("type fields :", f, ",val: ", event.type[f]);
						
					}
				}
				if (event.category) {
					this.record.category = event.category;
				}
			}
			$('description').innerText = this.record.value1;
			$('icon').src ="url(images/drawable/high" + this.type.iconid + ".png)";
			this.displayDateTypeAndCategory();
			this.unmaskRecord();
			this.maskRecord();
		}
	},

	displayDateTypeAndCategory: function() {
		var date = {
					 key:'Date Mod',
					 value:this.record.value10
				   }
		$('datemod').update(Mojo.View.render({
								object: date,
								template: 'detailedView/item',
								}));
			
		if (this.record.value10) {
			Mojo.Log.info("Show notes");
			
			$('datemodGroup').show();
		} else {
			Mojo.Log.info("Hide notes");
			
			$('datemodGroup').hide();
		}
		
		var type = {
						key: 'Type',
						value: this.type.name
					};
		$('type').update(Mojo.View.render({
								object: type,
								template: 'detailedView/item',
								}));
			
		if (this.type.name) {
			Mojo.Log.info("Show category");
			
			$('typeGroup').show();
		} else {
			Mojo.Log.info("Hide category");
			
			$('typeGroup').hide();
		}
		
		var category = {
						key: 'Category',
						value: this.record.category
					};
		$('category').update(Mojo.View.render({
								object: category,
								template: 'detailedView/item',
								}));
			
		if (this.record.category) {
			Mojo.Log.info("Show category");
			
			$('categoryGroup').show();
		} else {
			Mojo.Log.info("Hide category");
			
			$('categoryGroup').hide();
		}
		
		var notes = {
						key: 'Notes',
						value: this.record.notes
					};
		$('notes').update(Mojo.View.render({
								object: notes,
								template: 'detailedView/item',
								}));
			
		if (this.record.notes) {
			Mojo.Log.info("Show notes");
			
			$('notesGroup').show();
		} else {
			Mojo.Log.info("Hide notes");
			
			$('notesGroup').hide();
		}
	},
	
	setupTextWidget: function(name, hintText,index,value,handlerContentChange) {
		
		Mojo.Log.info('name: ', name, ", index: ", index, " value: ", value);
		
		var attrWidget = {
			hintText: hintText,
			multiline: true,												
		};	
		
		var widgetModel = {
			'index': index,
			'value': value,
			disabled: (handlerContentChange == undefined),
		};	

		this.controller.setupWidget(name, attrWidget, widgetModel);
		if (handlerContentChange) {
			this.controller.listen(name, Mojo.Event.propertyChange, handlerContentChange);
		}	
	},
	
	setupCommandMenu: function() {
		this.controller.setupWidget(Mojo.Menu.commandMenu, 
                undefined, 
                {items: [{items:[  
                                 { icon: "back", command: "goBack"},
								{label:'Edit', command: 'edit' },
								//{label:'More', 	   submenu:'view-menu'},
								//{label:'Mask/Unmask', command: 'mask'},
								]
						},{items:[           				    
								{label:'Mask/Unmask', command: 'mask'},
								]
						},{	items: [{
									iconPath: 'images/locknow.png',
									label: $L('Lock now'),
									command: ('lock')
									}]
								},]});
		this.viewMenuModel = { label: $L('More'), 
							   items: [ {label: $L('Mask/Unmask'), command: 'mask'}, 
							   			{label: $L('Set Password'),  command:'pwds'},													   
										{label: $L('Lock now'), command:'lock'},
									  ]
								};
	// Set up submenu widget that was wired into the viewMenu above
	//this.controller.setupWidget("view-menu", undefined, this.viewMenuModel);
           		
	},
	
	handleCommand: function(event) {
		
		if (event.type == Mojo.Event.commandEnable && (event.command == Mojo.Menu.helpCmd)) {
         	event.stopPropagation(); // enable help. now we have to handle it
    	}
		
		if (SplashIDWorld.timer) {
			SplashIDWorld.timer.reset();
		}
		if (event.type == Mojo.Event.command) {
			switch (event.command) {
				case 'mask':
					Mojo.Log.info("Mask/Unmask");
					
					if (this.mask == true) {
						this.unmaskRecord();
						this.mask = false;
					} else {
						this.maskRecord();
						this.mask = true;
					}
					break;
					
				case 'goBack':

				    this.controller.stageController.popScene();

				break;
	
				case 'edit':
					Mojo.Log.info('edit record:');
					
					this.controller.stageController.pushScene('editRecord',this.record, this.type, this.password);
					break;
					
			   case 'lock':
					 Mojo.Log.info('Lock now');
					 
					 if (SplashIDWorld.password) {
						var actScene = Mojo.Controller.stageController.activeScene();
						Mojo.Controller.stageController.pushScene('lock', actScene);
					 } else {
					 	this.showSetPasswordAlert();
					 }
					 break;
					 
			   case 'pwds':
					if (SplashIDWorld.password) {
						Mojo.Log.info ("ChangePwd dlg");
						
						this.setPwdDlg = this.controller.showDialog({
						template: 'changePassword/changePassword-scene',
						assistant: new ChangePasswordAssistant(this),
						});
					} else {
						this.setPwdDlg = this.controller.showDialog({
						template: 'setPassword/setPassword-scene',
						assistant: new SetPasswordAssistant(this),
						});
					}
					break;
				
				case(Mojo.Menu.helpCmd):
					Mojo.Controller.stageController.pushScene('support');
					break;
			
			}
		}
	},
	
	maskRecord: function() {
		Mojo.Log.info("maskRecord: mask val: ", this.type.mask, ",binarymask: ", this.type.mask.toString(2));
		
		var labelFields = [ this.type.field1, this.type.field2, this.type.field3, this.type.field4, this.type.field5,
						 	this.type.field6, this.type.field7, this.type.field8, this.type.field9 ];
		var fieldValues = [ this.record.value1, this.record.value2, this.record.value3, this.record.value4, this.record.value5, 
		                    this.record.value6, this.record.value7, this.record.value8, this.record.value9];
		for (var i = 0; i < labelFields.length; i++) {		
			if ((this.type.mask & (1 << i)) != 0 ) {
				if ( i == 0) {
					continue;
				}
				var j = i+1;
				var item = {
					key: labelFields[i],
					value:"******"
				};
				$('field' + j).update(Mojo.View.render({
					object: item,
					template: 'detailedView/item',
				}));
				
				if (fieldValues[i]) {
					Mojo.Log.info("Show field2Container");
					
					$('field' +j+'Group').show();
				}
				else {
					Mojo.Log.info("Hide field2Container");
					
					$('field' +j+ 'Group').hide();
				}
			} 								
		} 
	},
	
	unmaskRecord: function() {
		Mojo.Log.info("Unmask");
		
		var labelFields = [ this.type.field2, this.type.field3, this.type.field4, this.type.field5,
						 	this.type.field6, this.type.field7, this.type.field8, this.type.field9 ];
		var fieldValues = [ this.record.value2, this.record.value3, this.record.value4,
							this.record.value5, this.record.value6, this.record.value7, this.record.value8,
							this.record.value9];
		for (var i = 0; i < labelFields.length; ++i) {
			var j = i+2;
			Mojo.Log.info ("Record Values: ", fieldValues[i]);
			
			var item = {key:labelFields[i], value:fieldValues[i]};			
			$('field' + j).update(Mojo.View.render({
					object: item,
					template: 'detailedView/item',
				}));
				
			if (fieldValues[i]) {
				Mojo.Log.info("Show field2Container");
				
				$('field' +j+'Group').show();
			}
			else {
				Mojo.Log.info("Hide field2Container");
				
				$('field' +j+ 'Group').hide();
			}
        }
	},
	
	showSetPasswordAlert: function() {
		this.controller.showAlertDialog({
			title: 'Set Password',
			message: "Please make sure that you have set the password before using this feature.",
			preventCancel: true,
			choices: [{label:'OK', value:10}]
		});
	},
	
	onCancel: function() {
		if (SplashIDWorld.timer) {
			SplashIDWorld.timer.reset();
		}
		Mojo.Log.info("No password");
		
		this.setPwdDlg.mojo.close();
	},
	
})
