
EditRecordAssistant = Class.create({
	initialize: function(record, type, password) {
		this.record = record;
		this.password = password;
		this.fieldValues = [undefined, undefined, undefined, undefined, 
		                    undefined, undefined, undefined, undefined, undefined];
		
		this.selection = null;
		
		this.originalRecord = {};
		this.editedRecord = {};
		this.type = Object.clone(type);
		this.category = this.record.category;
		this.customType = undefined;
		this.originalRecord = Object.clone(record);
		this.editedRecord = Object.clone(record);
		Mojo.Log.info('edited record uid: ', this.editedRecord.uid, ", value1:", this.editedRecord.value1);
		Mojo.Log.info('edited reocrd customtypeuid: ', this.editedRecord.customtypeuid );
		Mojo.Log.info('Record uid: ', this.record.uid);
		for (f in this.type) {
			Mojo.Log.info('** type f: ', f, ", v: ", this.type[f]);
		}
		Mojo.Log.info(" ** type is: ", this.type.name, "    ** category is: ", this.category);
 	},
	
    setup: function() {
		Mojo.Log.info('setup:Edit Record');
		this.setupTextWidget('description', '', this.descriptionChanged.bind(this), undefined, this.record.value1, true);
		var labelsFields = ['field1', 'field2', 'field3', 'field4', 'field5', 
		                     'field6', 'field7', 'field8'];
		var values = [this.record.value2, this.record.value3, this.record.value4, this.record.value5, 
		              this.record.value6, this.record.value7, this.record.value8, this.record.value9];
		for (var i = 0; i < labelsFields.length; ++i) {
			this.setupTextWidget(labelsFields[i], '', this.fieldChanged.bind(this), i,values[i] , false);
		}
		this.setupTextWidget('datemod', '', undefined, undefined, this.record.value10, false);
		this.setupTextWidget('notes', '', this.notesChanged.bind(this), undefined, this.record.notes);
	
		this.setupIconPicker();
		this.TypesWidget = this.controller.get('types');
		
		/* setup the save, clear, customize fields, and return (command) menu items */
		this.setupCommandMenu();
		this.selection = new TypesAndCategoriesSelection(this,  
														 false, 
														 this.record.typeuid,
														 this.record.categoryuid);
		this.setupTypesAndCategoriesSelectionMenu();
		this.setTypeLabels(this.type);
		$('icon').src = "url(images/drawable/high" + this.type.iconid + ".png)";
		this.controller.listen('iconPicker', Mojo.Event.tap, this.showIconPicker.bindAsEventListener(this));
		//$('selectedType').value = this.type.name;
		//$('selectedCategory').value = this.record.category;
	},
	
	activate: function(event) {
		if (SplashIDWorld.timer) {
			Mojo.Log.info('calling timer reset from editRecords');
			SplashIDWorld.timer.reset();
		}
		if (event && event instanceof SplashIDEvent) {
			if (event.src == SplashIDWorld.Activities.CustomizeFieldsActivity) {
				this.customType = event.customType;
				for (field in this.customType) {
					Mojo.Log.info(field, ": ", this.customType[field]);
					this.setTypeLabels(this.customType);
					$('icon').src = "url(images/drawable/high" + this.customType.iconid + ".png)";
				}
			}
		}
	},
	
	popupTypes: function() {
		if (SplashIDWorld.timer) {
			SplashIDWorld.timer.reset();
		}
		if (this.selection) {
			this.selection.popupTypes(event);
		}
	},
	
	popupCategories: function() {
		if (SplashIDWorld.timer) {
			SplashIDWorld.timer.reset();
		}
		if (this.selection) {
			this.selection.popupCategories(event);
		}
	},
	
	OnCategorySelected: function(uid) {
		if (SplashIDWorld.timer) {
			SplashIDWorld.timer.reset();
		}
		var category = this.selection.categoryLabelsCmds[this.selection.chosenCategory];
		//$('selectedCategory').value = category.label;
		this.editedRecord.categoryuid = category.uid;
		this.category = category.label;
		
		for ( f in category) {
			Mojo.Log.info("*** category: ",  f, ",", category[f]);
		}
		
		this.viewMenuModel.items[1].label = category.label;
		this.controller.modelChanged(this.viewMenuModel);  

	},
	
	OnTypeSelected: function(uid) {
		if (SplashIDWorld.timer) {
			SplashIDWorld.timer.reset();
		}
		
		this.customType = null;
		
		var type = this.selection.typeLabelsCmds[this.selection.chosenType];
		//$('selectedType').value = type.label;
		this.editedRecord.typeuid = type.uid;
		this.editedRecord.customtypeuid = "";
		this.editedRecord.hascustomfield = 0;
		this.type = this.decryptTypeValues(type.typedata);
		this.setTypeLabels(this.type);
		Mojo.Log.info("******* type is: ", this.type.name);
		
		this.viewMenuModel.items[0].label = this.type.name;
		this.controller.modelChanged(this.viewMenuModel);  

	
	},
	
	setTypeLabels: function(typedata) {
		$('desc-label').innerText   = typedata.field1;
		$('field1-label').innerText = typedata.field2;
		$('field2-label').innerText = typedata.field3;
		$('field3-label').innerText = typedata.field4;
		$('field4-label').innerText = typedata.field5;
		$('field5-label').innerText = typedata.field6;
		$('field6-label').innerText = typedata.field7;
		$('field7-label').innerText = typedata.field8;
		$('field8-label').innerText = typedata.field9;
		$('icon').src ="url(images/drawable/high" + typedata.iconid + ".png)";
	},
	 
	setupIconPicker: function() {
		Event.observe('icon', Mojo.Event.tap, this.popupGridList.bindAsEventListener(this));
	},
	
	popupGridList: function() {
		Mojo.Log.info("icon picker");
	},
	
	setupTextWidget: function(name, hintText, handlerContentChange, index, value, focus) {
		var attrWidget = {
			hintText: hintText,
			multiline: true,
			enterSubmits: false,
			focusMode: Mojo.Widget.focusInsertMode,
			focus: focus,
			changeOnKeyPress: true,
		};
		var modelWidget = {
			'index': index,
			'value': value,
			disabled: (handlerContentChange == undefined),
		};

		this.controller.setupWidget(name, attrWidget, modelWidget);
		if (handlerContentChange) {
			this.controller.listen(name, Mojo.Event.propertyChange, handlerContentChange);
		}
	},
	
	notesChanged: function(event) {
		if (SplashIDWorld.timer) {
			SplashIDWorld.timer.reset();
		}
		this.editedRecord.notes = event.value;
	},
	
	fieldChanged: function(event) {
		if (SplashIDWorld.timer) {
			SplashIDWorld.timer.reset();
		}		
		this.fieldValues[event.model.index] = event.value;
		console.log('field changed: value '+ event.value);
	},
	
	descriptionChanged: function(event) {
		if (SplashIDWorld.timer) {
			SplashIDWorld.timer.reset();
		}
		this.editedRecord.value1 = event.value;
	},
	
	setupTypesAndCategoriesSelectionMenu: function() {
		
		this.viewMenuModel = {items: [{label:this.type.name, command:'type', width:155},
                               				 {label:this.category, command:'category', width:155}]
	                           		};

		this.controller.setupWidget(Mojo.Menu.viewMenu, 
				                    undefined, 
				                    this.viewMenuModel);
	},
	
	setupCommandMenu: function() {
		this.controller.setupWidget(Mojo.Menu.commandMenu, 
                undefined, 
                {items: [{items: [
                                  { icon: "back", command: "goBack"},
                                  {label:'Save',     command:'save'}
                          ]},
						 {items: [{label:'Customize', command:'cust'}]}
           				]
           		});
		this.controller.setupWidget();
	},
	
	fillEditedRecordDetails: function() {
		Mojo.Log.info('EditRecordAssistant - fillEditedRecordDetails');
		if (this.fieldValues[0] != undefined) this.editedRecord.value2 = this.fieldValues[0].strip();
		if (this.fieldValues[1] != undefined) this.editedRecord.value3 = this.fieldValues[1].strip();
		if (this.fieldValues[2] != undefined) this.editedRecord.value4 = this.fieldValues[2].strip();
		if (this.fieldValues[3] != undefined) this.editedRecord.value5 = this.fieldValues[3].strip();
		if (this.fieldValues[4] != undefined) this.editedRecord.value6 = this.fieldValues[4].strip();
		if (this.fieldValues[5] != undefined) this.editedRecord.value7 = this.fieldValues[5].strip();
		if (this.fieldValues[6] != undefined) this.editedRecord.value8 = this.fieldValues[6].strip();
		if (this.fieldValues[7] != undefined) this.editedRecord.value9 = this.fieldValues[7].strip();
	},
	
	updateRecordValues: function() {
		Mojo.Log.info('EditRecordAssistant - updateRecordValues');
		if (SplashIDWorld.timer) {
			SplashIDWorld.timer.reset();
		}
		
		Mojo.Log.info('****************Custom Type******************: ');
		this.fillEditedRecordDetails();
		var recordValues = new ContentValues();
		var labelsFields = ['value1','value2', 'value3', 'value4', 'value5', 'value6', 
                            'value7', 'value8', 'value9'];
		
		for (i = 0; i < labelsFields.length; i++) {
			if (this.editedRecord[labelsFields[i]]) {
				recordValues.put(labelsFields[i], this.editedRecord[labelsFields[i]]);
				Mojo.Log.info(labelsFields[i], ": ", this.editedRecord[labelsFields[i]]);
			console.log (labelsFields[i] +  ": " + this.editedRecord[labelsFields[i]]);
			}
		}

		if (this.editedRecord.notes && !this.editedRecord.notes.blank()) {
			recordValues.put('notes', this.editedRecord.notes);
		}

		if (SplashIDWorld.database == undefined) {
			SplashIDWorld.database = new SQLOperations('splashid');
		}
		
		var resultHandler = new Array();	
		resultHandler.push(this.onSuccess.bind(this));
		resultHandler.push(this.onFailure.bind(this));

		var updatedRec = new ContentValues();
		var currDate = getFormattedDate();
		Mojo.Log.info('before encryption:');
		updatedRec = encryptRecord(SplashIDWorld.password, recordValues);
		updatedRec.put('value10', currDate);
		updatedRec.put('typeuid', this.editedRecord.typeuid);
		
		Mojo.Log.info('***** run type id: ', this.editedRecord.typeuid);
		
		updatedRec.put('categoryuid', this.editedRecord.categoryuid);
		Mojo.Log.info('***** 1 run custom type id: ', this.editedRecord.customtypeuid);
		if (this.editedRecord.customtypeuid != undefined) {
			updatedRec.put('customtypeuid', this.editedRecord.customtypeuid);
			
			Mojo.Log.info('***** run custom type id: ', this.editedRecord.customtypeuid);
			
		}
		updatedRec.put('hascustomfield', this.editedRecord.hascustomfield);
		Mojo.Log.info('after encryption:');
		SplashIDWorld.database.updateRecord("recordstable", updatedRec, "duid=" + this.editedRecord.duid, resultHandler);						
	
	},
	
	handleCommand: function(event) {
		
		if (event.type == Mojo.Event.commandEnable && (event.command == Mojo.Menu.helpCmd)) {
         	event.stopPropagation(); // enable help. now we have to handle it
    	}		
		
		if (SplashIDWorld.timer) {
			SplashIDWorld.timer.reset();
		}
		if(event.type == Mojo.Event.command) {
			if(event.command == 'type') {
				this.selection.popupTypes(event);
			} else if (event.command == 'category') {
				this.selection.popupCategories(event);
			} else if (event.command == 'save') {
				if (this.editedRecord.value1.blank()) {
					this.showEmptyDescriptionAlert();
				} else {
					var customTypeuid;
					if (this.isTypeCustomized() && this.editedRecord.customtypeuid) {
						this.updateCustomType(this.customType);
					} else if (this.isTypeCustomized()) {
						customTypeuid = this.insertTypeToCustomTypes(this.customType);
						Mojo.Log.info('custom typeuid: ', customTypeuid);
					} else {
						
						this.updateRecordValues();
					}
				}
			} else if (event.command == 'goBack') {
				this.controller.stageController.popScene();				
			} else if (event.command == 'cust') {
				Mojo.Log.info("customize fields");				
				this.customizeFields(this.editedRecord);
			} else if (event.command == Mojo.Menu.helpCmd) {
				Mojo.Controller.stageController.pushScene('support');
			}
		}
	},
	
	showEmptyDescriptionAlert: function() {
		if (SplashIDWorld.timer) {
			SplashIDWorld.timer.reset();
		}
		this.controller.showAlertDialog({
			title: 'Alert - Invalid Field Value',
			message: "Please make sure the 'Description' field is not empty",
			preventCancel: true,
			choices: [{label:'ok', value:10}]
		});
	},
	
	customizeFields: function(type) {
		Mojo.Log.info('EditRecordAssistant - customizeFields');	

		if (SplashIDWorld.database == undefined) {
			SplashIDWorld.database = new SQLOperations('splashid');
		}

		var query = "";
		if (type.customtypeuid) {
			//type.customtypeuid;
			query = "SELECT * FROM customtypestable WHERE uid='" + type.customtypeuid + "'";
		}
		else {
			//type.typeuid;
			query = "SELECT * FROM typestable WHERE uid='" + type.typeuid + "'";
		}

		// have result handlers and bind these with sql operations
		var resultHandler = new Array();	
		resultHandler.push(this.onCustomSuccess.bind(this));
		resultHandler.push(this.onFailure.bind(this));
		
		Mojo.Log.info("query: ", query);				
		SplashIDWorld.database.retrieveRecord(query, resultHandler);

	},
	
	onFetchType: function(record) {
		Mojo.Log.info("EditRecordAssistant - onFetchType");
		if (record) {
			var decType = this.decryptTypeValues(record);
			this.controller.stageController.pushScene('customFields', decType);
		}
	},
	
	isTypeCustomized: function() {
		var isCustom = false;
		if (this.customType) {
			Mojo.Log.info("Custom type object exists");
			for (field in this.customType) {
				Mojo.Log.info ("field : ", field, ",ctval: ", this.customType[field], ",typeval: ", this.type[field]);
				if (this.customType[field] != this.type[field]){
					isCustom = true;
				}
			}
		}
		Mojo.Log.info("isCustom: ",  isCustom);
		return isCustom;
	},
	
	insertTypeToCustomTypes: function(customType) {
		Mojo.Log.info("EditRecordAssistant - insertTypeToCustomTypes");	
		if (SplashIDWorld.timer) {
			SplashIDWorld.timer.reset();
		}
		var customTypeValues = new ContentValues();
		var recordValues = new ContentValues();
		var fields = ['name', 'field1', 'field2', 'field3', 'field4',
		              'field5', 'field6', 'field7', 'field8', 'field9'];
		var labelsFields = ['value1','value2', 'value3', 'value4', 'value5', 'value6', 
                            'value7', 'value8', 'value9'];	
		var uid = new UUID().toString();
		uid = uid.split('-').join('');
		uid = uid.substring(uid.length-16, uid.length);
		
						  
		for (i = 0; i < fields.length; i++) {
			if (customType[fields[i]] != undefined && !customType[fields[i]].blank() ) {
				customTypeValues.put(fields[i], customType[fields[i]]);
			}
		}
		
		this.fillEditedRecordDetails();
		
		for (i = 0; i < labelsFields.length; i++) {
			if (this.editedRecord[labelsFields[i]]) {
				recordValues.put(labelsFields[i], this.editedRecord[labelsFields[i]]);
			}
		}
		if (this.editedRecord.notes && !this.editedRecord.notes.blank()) {
			recordValues.put('notes', this.editedRecord.notes);
		}

		if (SplashIDWorld.database == undefined) {
			SplashIDWorld.database = new SQLOperations('splashid');
		}
		
		var resultHandler = new Array();	
		resultHandler.push(this.onInsertCustomSuccess.bind(this));
		resultHandler.push(this.onFailure.bind(this));

		SplashIDWorld.count = 0;
		
		var encCustomType = new ContentValues();		
		encCustomType = encryptRecord(SplashIDWorld.password, customTypeValues);
		encCustomType.put('uid', uid);
		encCustomType.put('iconid', customType.iconid);
		encCustomType.put('mask', customType.mask);
		SplashIDWorld.database.insertRecord("customtypestable", encCustomType, resultHandler);
		
		var encRecord = new ContentValues();
		encRecord = encryptRecord(SplashIDWorld.password, recordValues);
		encRecord.put('uid', this.editedRecord.uid);
		encRecord.put('duid', this.editedRecord.duid);
		encRecord.put('hascustomfield', 1);
		encRecord.put('customtypeuid', uid);
		encRecord.put('typeuid', this.editedRecord.typeuid);
		encRecord.put('categoryuid', this.editedRecord.categoryuid);
		var currDate = getFormattedDate();
		encRecord.put('value10', currDate);
		SplashIDWorld.database.updateRecord("recordstable", encRecord, "duid=" + this.editedRecord.duid, resultHandler);					

	},
	
	updateCustomType: function(customType) {
		Mojo.Log.info("******** EditRecordAssistant - updateCustomType");	
		if (SplashIDWorld.timer) {
			SplashIDWorld.timer.reset();
		}
		var customTypeValues = new ContentValues();
		var recordValues = new ContentValues();
		
		var fields = ['field1', 'field2', 'field3', 'field4',
		              'field5', 'field6', 'field7', 'field8', 'field9'];
		for (i = 0; i < fields.length; i++) {
			if (customType[fields[i]]) {
				customTypeValues.put(fields[i], customType[fields[i]]);
			}
		}
		this.fillEditedRecordDetails();
		var labelsFields = ['value1','value2', 'value3', 'value4', 'value5', 'value6', 
                            'value7', 'value8', 'value9'];
		
		for (i = 0; i < labelsFields.length; i++) {
			if (this.editedRecord[labelsFields[i]]) {
				recordValues.put(labelsFields[i], this.editedRecord[labelsFields[i]]);
			}
		}
		if (this.editedRecord.notes && !this.editedRecord.notes.blank()) {
			Mojo.Log.info("notes is present");
			recordValues.put('notes', this.editedRecord.notes);
		}
	
		if (SplashIDWorld.database == undefined) {
			SplashIDWorld.database = new SQLOperations('splashid');
		}
		
		var resultHandler = new Array();	
		resultHandler.push(this.onUpdateCustomSuccess.bind(this));
		resultHandler.push(this.onFailure.bind(this));

		SplashIDWorld.count = 0;

		Mojo.Log.info("update customtypes");
		var encCustomType = new ContentValues();
		var encRecord = new ContentValues();
		encCustomType = encryptRecord(SplashIDWorld.password, customTypeValues);
		encCustomType.put('iconid', customType.iconid);
		encCustomType.put('mask', customType.mask);
		SplashIDWorld.database.updateRecord("customtypestable", encCustomType, "uid='" + this.editedRecord.customtypeuid + "'", resultHandler);

		encRecord = encryptRecord(SplashIDWorld.password, recordValues);
		encRecord.put('uid', this.editedRecord.uid);
		encRecord.put('duid', this.editedRecord.duid);
		encRecord.put('typeuid', this.editedRecord.typeuid);
		encRecord.put('categoryuid', this.editedRecord.categoryuid);
		encRecord.put('hascustomfield', this.editedRecord.hascustomfield);
		encRecord.put('customtypeuid', this.editedRecord.customtypeuid);
		var currDate = getFormattedDate();
		encRecord.put('value10', currDate);
		SplashIDWorld.database.updateRecord("recordstable", encRecord, "duid=" + this.editedRecord.duid, resultHandler);	

	},
	
	decryptTypeValues: function(record) {
		var decrTypeVals = [];
		var decTypeName = "";
		var typeFields = ['field1', 'field2','field3', 'field4','field5',
						  'field6','field7', 'field8','field9'];
		var typeVals = [record.field1, record.field2, record.field3, record.field4, record.field5,  
						record.field6, record.field7, record.field8, record.field9];
		for (var i = 0; i < typeFields.length; i++) {
			if (SplashIDWorld.password && !SplashIDWorld.password.blank()) {
				if (typeVals[i] != undefined) {
					decrTypeVals[i] = Mojo.Model.decrypt(SplashIDWorld.password, typeVals[i]);
					Mojo.Log.info('values[', i, '] ', typeVals[i], " decrypted: ", decrTypeVals[i]);
				}
			} else {
				if (typeVals[i]) {
					decrTypeVals[i] = typeVals[i];
				}
			}
		}
		
		if (SplashIDWorld.password && !SplashIDWorld.password.blank()) {
			decTypeName = Mojo.Model.decrypt(SplashIDWorld.password, record.name);
		} else { 
			decTypeName = record.name; 
		}
		Mojo.Log.info("type name: ", decTypeName);
		var type = {
					 'uid': record.typeuid,
					 'iconid': record.iconid,
					 'name': decTypeName, 
					 'mask': record.mask, 
					 'field1': decrTypeVals[0],
					 'field2': decrTypeVals[1], 
					 'field3': decrTypeVals[2],
					 'field4': decrTypeVals[3],
					 'field5': decrTypeVals[4],
					 'field6': decrTypeVals[5],
					 'field7': decrTypeVals[6], 
					 'field8': decrTypeVals[7], 
					 'field9': decrTypeVals[8]
					};
		return type;
	},
	
	showIconPicker: function(event) {
		Mojo.Log.info("EditRecordAssistant - showIconPicker");	
		if (SplashIDWorld.timer) {
			SplashIDWorld.timer.reset();
		}
		Mojo.Log.info("Show Icon picker");
		this.iconPickerDlg = this.controller.showDialog({
						template: 'iconPicker/iconPicker-scene',
						assistant: new IconPickerAssistant(this),
						});
	},
	
	onIconSelected: function(iconid) {
		Mojo.Log.info("EditRecordAssistant - onIconSelected");	
		if (SplashIDWorld.timer) {
			SplashIDWorld.timer.reset();
		}
		if (!this.customType) {
			this.customType = Object.clone(this.type);
		}

		if (iconid.length != 0) {
			this.customType.iconid = iconid;
			$('icon').src ="url(images/drawable/high" + iconid + ".png)";
		}
	},
	
	closeIconPicker: function() {
		if (SplashIDWorld.timer) {
			SplashIDWorld.timer.reset();
		}
		this.iconPickerDlg.mojo.close();
	},
	
	onSuccess: function() {
		Mojo.Log.info("EditRecordAssistant - onSuccess");	

		var event = new SplashIDEvent().setParams(SplashIDWorld.Activities.EditRecordActivity);
		event.editedRecord = this.editedRecord;
		event.customType = this.customType;	
		event.type = this.type;
		event.category = this.category;
		SplashIDWorld.Flags.RecordEdited = true;
		this.controller.stageController.popScene(event);

	},
	
	onCustomSuccess: function (transaction, sqlResultSet) {
		Mojo.Log.info("EditRecordAssistant - onCustomSuccess");	
		Mojo.Log.info("Length:", sqlResultSet.rows.length);
		this.onFetchType(sqlResultSet.rows.item(0));
	},
	
	onInsertCustomSuccess: function() {
		Mojo.Log.info("**** EditRecordAssistant - onInsertCustomSuccess");	
		SplashIDWorld.count++;
		if (SplashIDWorld.count == 2) {
			Mojo.Log.info("count is 2");	
			var event = new SplashIDEvent().setParams(SplashIDWorld.Activities.EditRecordActivity);
			event.editedRecord = this.editedRecord;
			event.customType = this.customType;
			event.category = this.category;
			SplashIDWorld.Flags.RecordEdited = true;
			this.controller.stageController.popScene(event);
		}
	},
	

	onUpdateCustomSuccess: function() {
		Mojo.Log.info("**** EditRecordAssistant - onUpdateCustomSuccess");	
		SplashIDWorld.count++;
		if (SplashIDWorld.count == 2) {
			Mojo.Log.info("count is 2");	
			Mojo.Log.info("add custom Types");
			var event = new SplashIDEvent().setParams(SplashIDWorld.Activities.EditRecordActivity);
			event.editedRecord = this.editedRecord;
			event.customType = this.customType;
			event.category = this.category;
			SplashIDWorld.Flags.RecordEdited = true;
			this.controller.stageController.popScene(event);
		}
	},	

	onFailure: function(transaction, error) {
		Mojo.Log.info("EditRecordAssistant - onFailure");			
		Mojo.Log.info('Error was ', error.message, ' (Code ', error.code, ')');

	},	
})